#include "stdafx.h"
#include "suggest.h"

#include "SuggestEdit.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CSuggestEdit::CSuggestEdit() {
    m_strText = _T("");
    // sample
    m_aKey.Add(_T("foo"));
    m_aKey.Add(_T("bar"));
    m_aKey.Add(_T("baz"));
    m_aKey.Add(_T("bazbazbaz"));
}

CSuggestEdit::~CSuggestEdit() {
}

BEGIN_MESSAGE_MAP(CSuggestEdit, CEdit)
    //{{AFX_MSG_MAP(CSuggestEdit)
    ON_CONTROL_REFLECT(EN_UPDATE, OnUpdate)
    //}}AFX_MSG_MAP
END_MESSAGE_MAP()

void
CSuggestEdit::OnUpdate() {
    CString strText;
    GetWindowText(strText);

    if (m_strText.GetLength() < strText.GetLength()) {
        for (int i = 0; i < m_aKey.GetSize(); i++) {
            CString& strKey = m_aKey.GetAt(i);
            int nKey = strKey.GetLength();
            int nText = strText.GetLength();
            if (nText < nKey) {
                CString& strKeyLeft = strKey.Left(nText);
                if (strKeyLeft == strText) {
                    SetWindowText(strKey);
                    SetSel(nText, nKey, TRUE);
                    break;
                }
            }
        }
    }
    m_strText = strText;
}
